﻿local versionstring = "r100"
local L = MountifulLocalization
local mountifulcreated = false
local invalidnames = {"hide","remove","add","smart","mounts","safeflying","options","rebuild","debug", "dismiss", "help", "reset", "pet"} -- Don't let people use these as category names
local petsummoned = false
local lastpetsummoned = 0
local Mountiful_Defaults = {}
local Mountiful_Mounts = {}
local rtcf
local mountifulselectednum
local mountifulpagenum
local Mountiful_flyableSubZones = {"Krasus' Landing",}
local Companion_Counts = {Mount = 0, Pet = 0}


if (not L) then  --apparently this only bugs out on devs.  curse somehow changes variables when i upload it to make things work.  Thats cool and all, but not very helpful to me.  So i had to throw this in.
	MOprint("Error in Mountiful.  No Localization found?")
	--other localization stuff here?
	L = {}
	setmetatable(L, {__index = function(self, key)
		--if MOdebug then ChatFrame3:AddMessage('Please localize: '..tostring(key)) end
		rawset(self, key, key)
		return key
	end })
else
	Mountiful_flyableSubZones = {
		L["Krasus' Landing"],
	}
end

tinsert(UISpecialFrames, "Mountiful") -- Insert the menu frame into UISpecialFrames to it will close when hitting ESC

local MOprintstack = -1
local messagestring = ""
function MOprint(message)
   if(MOdebug) then
		if(MOprintstack == -1) then
			messagestring=""
		end
      local stack, filler
      if not message then
	  	 DEFAULT_CHAT_FRAME:AddMessage(messagestring..tostring(message))
		 return false 
      end
      MOprintstack=MOprintstack+1
      
	  filler=string.rep(". . ",MOprintstack)
      
      if (type(message) == "table") then
	  	-- DEFAULT_CHAT_FRAME:AddMessage("its a table.  length="..MO_tcount(message))
	 	
		DEFAULT_CHAT_FRAME:AddMessage(messagestring.."{table} --> ")
		
	 	for k,v in pairs(message) do
			messagestring = filler.."["..k.."] = "
	    	MOprint(v)
	 	end
      elseif (type(message) == "userdata") then

      elseif (type(message) == "function") then
        DEFAULT_CHAT_FRAME:AddMessage(messagestring.." A Function()")
      elseif (type(message) == "boolean") then
            DEFAULT_CHAT_FRAME:AddMessage(messagestring..tostring(message))
      else
	  	 	DEFAULT_CHAT_FRAME:AddMessage(messagestring..tostring(message))
      end
      MOprintstack=MOprintstack-1
   end
end


-- Checks if value e is in array t

local function in_array(e, t) 
	if(type(t) ~= "table") then 
		MOprint("ERROR!   passed in a nonexistant table!")
		return false
	end;
 	for _,v in pairs(t) do
		if (v==e) then return true end
	end
	return false
end

function Mountiful_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED")
	this:RegisterEvent("COMPANION_LEARNED");

	--Register Slash Commands
	SLASH_MOUNT1 = "/mountiful"
	SLASH_MOUNT2 = "/mount" -- A shortcut or alias
	SlashCmdList["MOUNT"] = function(arg) Mountiful_Command(arg, false); end;

	SLASH_PET1 = "/pet"
	SlashCmdList["PET"] = function(arg) Mountiful_Command(arg, true); end;


	-- Binding Variables
	BINDING_HEADER_MOUNTIFULHDR = "Mountiful Bindings"
	BINDING_NAME_MOUNTIFULBIND1 = "Smart Mounting"
	BINDING_NAME_MOUNTIFULBIND2 = "Pre-Selected Smart Mounting"
	BINDING_NAME_MOUNTIFULBIND3 = "FastGround"
	BINDING_NAME_MOUNTIFULBIND4 = "FastFlying"
	BINDING_NAME_MOUNTIFULBIND5 = "Pet"
	
end

function Mountiful_OnEvent()
	if (event == "VARIABLES_LOADED") then
		Mountiful_Loaded()
	elseif (event == "COMPANION_LEARNED") then -- Rebuild selections array when user learns a new mount/pet
		Mountiful_RebuildSelections()
	end
end

function Mountiful_Loaded()
	Mountiful_Defaults = {
		["Options"] = {
			revision = 85,
			safeflying = true,
			debugging = false,
		},
		["Categories"] = {
			[1] = "FastGround",
			[2] = "FastFlying",
			[3] = "SlowGround",
			[4] = "SlowFlying",
			[5] = "ExtremeFlying",
			[6] = "Swimming",
			[7] = "Qiraj",
			[8] = "All",
			[9] = "Pet",
		},
		["Categories_Selections"] = {
			["Pet"] = {
				ispet = true,
			},
		},
	}
	Mountiful:EnableMouse()
	Mountiful:SetScript("OnMouseDown", function()  
		Mountiful:StartMoving()
	end)
	Mountiful:SetScript("OnMouseUp", function()  
		Mountiful:StopMovingOrSizing()
	end)
	
	mountifulpagenum = 1
	
	--Mountiful:SetScript("OnShow",Mountiful_Refresh)  --things just isnt happening when its sopposed to.  maybe this will fix it.
			
	--patch into the blizzard mount screen
	local tabbutton = CreateFrame("Button","PetPaperDollFrameTab4", PetPaperDollFrameCompanionFrame,"TabButtonTemplate")
	tabbutton:SetID(4)  --needed?  not sure
	tabbutton:SetPoint("left",PetPaperDollFrameTab3,"right")
	--tabbutton:SetWidth(160)
	tabbutton:SetText("Mountiful")
	getglobal(tabbutton:GetName().."HighlightTexture"):SetWidth(tabbutton:GetTextWidth() + 31);
	PanelTemplates_TabResize(tabbutton, 0);
	tabbutton:SetFrameLevel(PetPaperDollFrameCompanionFrame:GetFrameLevel()+1);
	
	tabbutton:SetScript("OnClick", function()
		Mountiful_Command("")
	end)
	
	
	--jomar code.  seems overly complicated, but whatever.  it works.
	if Mountiful_Vars and Mountiful_Vars.version then
		Mountiful_Vars = nil
	end
	if not Mountiful_Vars then
		Mountiful_Vars = Mountiful_Defaults
	end

	-- If the revision in the Saved Vars is lower then the one in the defaults rebuild the saved vars
	if Mountiful_Vars["Options"]["revision"] < Mountiful_Defaults["Options"]["revision"] then
		MOprint("|C00aa00ffRevision change detected")
		Mountiful_Vars["Options"]["revision"] = Mountiful_Defaults["Options"]["revision"] -- Update the SV revision

		Mountiful_Vars["Categories_Selections"] = {}
		
		--Convert the panes array to the categories array
		if Mountiful_Vars.panes then
			MOprint("Replacing var_Categories with vars.panes")
			Mountiful_Vars["Categories"] = Mountiful_Vars.panes
		end
		
		-- Copy the categories in the selections
		for k, v in ipairs(Mountiful_Vars["Categories"]) do
			Mountiful_Vars["Categories_Selections"][v] = Mountiful_Vars["Categories"][v]
		end

		-- If an index in the defaults doesn't exist in the Saved Vars add it in
		for k, v in pairs(Mountiful_Defaults) do
			if not Mountiful_Vars[k] then
				Mountiful_Vars[k] = Mountiful_Defaults[k]
			end
		end

		-- If an index in the Saved Vars doesn't exist in the Defaults remove it
		for k, v in pairs(Mountiful_Vars) do
			if not Mountiful_Defaults[k] then
				Mountiful_Vars[k] = nil
			end
		end
	end
	
	Mountiful_Options = Mountiful_Vars["Options"]
	Mountiful_Categories = Mountiful_Vars["Categories"]
	Mountiful_Selections = Mountiful_Vars["Categories_Selections"]
	
	--[[ This seems to check if each value in Categories is in Categories, so it shouldn't end up actually doing anything
	local Categoryfound
	--add all the defaults
	for j = 1,#Mountiful_Categories do
		Categoryfound = false
		for i = 1,#Mountiful_Categories do
			if (Mountiful_Categories[i] == Mountiful_Categories[j]) then
				Categoryfound = true
				break
			end
		end
		if not Categoryfound then
			Mountiful_Categories[#Mountiful_Categories+1] = Mountiful_Categories[j]
		end
	end
	--]]

	Mountiful_CreateMountTables()
	Mountiful_CreateMainFrame()
	
	MOprint("|c00ffaaaa END Loaded")
end
function Mountiful_GetCommand(msg)
	if msg then
		local a,b,c=strfind(msg, "(%S+)") --contiguous string of non-space characters
		if a then
			return c, strsub(msg, b+2)
		else	
			return ""
		end
	end
end

function Mountiful_Command(msg, ispet) -- Parse the slash commands
	local rand
	--MOprint("Command recieved:"..msg.."  ispet="..tostring(ispet))

	local msg = SecureCmdOptionParse(msg)
	local Cmd, SubCmd = Mountiful_GetCommand(msg)
	
	--MOprint("Command:"..Cmd.."  Sub:"..tostring(SubCmd))
	
	local tmpcmd, ismountcmd
		for i, panel in pairs(Mountiful_Categories) do -- Check to see if the cmd matches the name of a category
			if (type(panel) == "string") then
				tmp = strlower(panel)
				Cmd = strlower(Cmd)
				if (Cmd == tmp) then
					ismountcmd = true
					tmpcmd = panel
					break
				end
			end
		end
		if (Cmd == "help") then
			print(L["/mount <Category> - Uses a random mount from that category"])
			print(L["/mount smart - Uses a random mount that suits your location"])
			print(L["/mount smart pre - Uses a random mount from your Flying/Ground lists depending on your location"])
			print(L["/(mount|pet) pet - Uses a random companion"])
			print(L["/(mount|pet) pet pre - Uses a random pre-selected companion"])
			print(L["/(mount|pet) add <Category> - Adds a new category"])
			print(L["/(mount|pet) remove <Category> - Removes a category"])
			print(L["/mount safeflying - Toggles safe flying on|off"])
			print(L["/mount reset - Resets all settings for Mountiful, also causes your ui to reload"])
			print(L["/mount debug - Toggles debug messages on|off"])
		elseif (Cmd == "hide") then
			Mountiful:Hide()
		elseif (Cmd == "reset") then
			Mountiful_ResetSettings()
		elseif (Cmd == "add") then
			Mountiful_AddPanel(SubCmd, ispet)
		elseif (Cmd == "remove") then
			Mountiful_RemovePanel(SubCmd)
		elseif (Cmd == "dismiss") then
			DismissCompanion("CRITTER")
			petsummoned = false
		elseif (Cmd == "smart") then
			if SubCmd == "pre" or SubCmd == "predefined" then
				Mountiful_SmartMount(true)
			else
				Mountiful_SmartMount()
			end
		elseif (Cmd == "rebuildselections") then
			print(L["Rebuilding mount selections database"])
			Mountiful_RebuildSelections()
		elseif (Cmd == "debug") then
			MOdebug = not MOdebug
			print(tostring(MOdebug))
		elseif (Cmd == "safeflying") then
			Mountiful_Options.safeflying = not Mountiful_Options.safeflying
			if Mountiful_Options.safeflying then
				print(L["Safe dismounting on"])
			else
				print(L["Safe dismounting off"])
			end
		elseif (ismountcmd) then -- If the command matched the name of a category call the mount function
			if SubCmd == "pre" or SubCmd == "predefined" then
				Mountiful_Mount(tmpcmd,true)
			else
				Mountiful_Mount(tmpcmd)
			end
		else	
			if(Mountiful:IsVisible()) then
				Mountiful:Hide()
			else
				Mountiful:Show()
			end
		end
end
function Mountiful_CreateMainFrame()
	if mountifulcreated then return; end
	mountifulcreated = true
	
	local title = _G["Mountiful_Frame_Title"]
	title:SetText(title:GetText()..versionstring)
	
	local parent = getglobal("Mountiful")
	parent:SetScript("OnShow",Mountiful_update)
	local leftpanel = getglobal("Mountiful_LeftPane")
	local leftpanelheight = leftpanel:GetHeight()
	local rightpanel = CreateFrame("Frame", "mountifulrightpanel", parent, "RightPane_Template")
	local paneltext = getglobal(rightpanel:GetName().."_Name")
	local button = CreateFrame("Button", nil, leftpanel, "LeftMenuButton")
	local buttonheight = button:GetHeight()
	rtcf = math.floor(leftpanelheight / buttonheight)  --rows that can fit
	
	for i = 1,rtcf do
		button = CreateFrame("Button", "mountifulleftmenubutton"..i, leftpanel, "LeftMenuButton")
		if(i == 1) then
			button:SetPoint("top",0,-4)
		else
			button:SetPoint("top",getglobal("mountifulleftmenubutton"..i-1),"bottom")
		end
	end
	
	local rows = 4
	local columns = 6
	
	for i = 1,rows*columns do
		local mounticon = CreateFrame("Frame", "mountifulicon"..i, rightpanel, "MountifulIcon")
		if (i == 1) then
			firstinrow = mounticon
			mounticon:SetPoint("topleft",16,-26)
		elseif (mod(i, columns) == 1) then
			mounticon:SetPoint("TOPLEFT", firstinrow, "BOTTOMLEFT", 0, 0)
			firstinrow = mounticon
		else
			mounticon:SetPoint("TOPLEFT", previcon, "TOPRIGHT", 0, 0)
		end
		
		previcon = mounticon
	end
	
	getglobal(rightpanel:GetName().."_NextPage"):SetScript("OnClick",Mountiful_NextPage)
	getglobal(rightpanel:GetName().."_PrevPage"):SetScript("OnClick",Mountiful_PrevPage)

	Mountiful_update()
	
end


function Mountiful_update()
--graphical stuff
	MOprint("MOuntiful_update()  mountifulpagenum="..mountifulpagenum)
	Mountiful_updateleftpanel()
	Mountiful_updaterightpanel()

end
function Mountiful_updateleftpanel()
	local buttoni = 1
	for i, category in ipairs(Mountiful_Categories) do
		button = getglobal("mountifulleftmenubutton"..buttoni)
		button.categorynum = i
		button.name = category
		button.index = buttoni
		if(Mountiful_Mounts[category] and #Mountiful_Mounts[category] > 0) then
			button:Show()
			button:SetText(category.." ("..#Mountiful_Mounts[category]..")")
			buttoni=buttoni+1
		elseif(Mountiful_Mounts[category] and #Mountiful_Mounts[category] <= 0) then
			--dont show 0 count categories?  --skip.  dont increment buttoni
			
		else  -- its a custom category
			button:Show()
			button:SetText(category)
			buttoni=buttoni+1
		end
		
		if(i == mountifulselectednum) then
			button:SetText("|c0000ff55"..tostring(button:GetText()))  --greeny
		end
		
	end
	button = getglobal("mountifulleftmenubutton"..buttoni) --hide non used
	while (button) do
		button:Hide()
		buttoni = buttoni + 1
		button = getglobal("mountifulleftmenubutton"..buttoni)
	end
	
end


function Mountiful_updaterightpanel()
	
	local ispet=false
	local rightpanel = getglobal("mountifulrightpanel")
	local paneltext = getglobal(rightpanel:GetName().."_Name")
			
	local endmountnum = mountifulpagenum * 24
	local startmountnum = (mountifulpagenum * 24) - 23
	local mountname, spellID, icon
	local button 
	local mounttexture
	local checkbox
	local iconi=1
	
	if(not mountifulselectednum) then
		mountifulselectednum = 1 --first entry (fastflying, i think)
	end
	
	--MOprint("Mountiful_Categories")
	--MOprint(Mountiful_Categories)
	
	
	panelname = Mountiful_Categories[mountifulselectednum]
	if (not mountifulpagenum) then
		mountifulpagenum = 1
	end
	paneltext:SetText(panelname.." Page "..mountifulpagenum)
	if (Mountiful_Selections[panelname] and Mountiful_Selections[panelname].ispet) then
		ispet = true
		companionType = "CRITTER";
	else
		companionType = "MOUNT";
	end
	local mounts = {}
	if(ispet) then
		mounts = Mountiful_Mounts.Pet
	elseif(Mountiful_Mounts[panelname]) then
		mounts = Mountiful_Mounts[panelname]
	else
		mounts = Mountiful_Mounts.All
	end
	
	if #mounts <= (mountifulpagenum * 24) then -- Disable the next page button if there is only one page
		getglobal(rightpanel:GetName().."_NextPage"):Disable()
	else
		getglobal(rightpanel:GetName().."_NextPage"):Enable()
	end
	if(mountifulpagenum == 1 ) then
		getglobal(rightpanel:GetName().."_PrevPage"):Disable()
	else
		getglobal(rightpanel:GetName().."_PrevPage"):Enable()
	end
	

	for i = startmountnum,endmountnum do
		if (not mounts[i]) then break end;
		 _, mountname, spellID, icon, _ = GetCompanionInfo(companionType, mounts[i])
		if not mountname then break end;
		mounticon = getglobal("mountifulicon"..iconi)
		mounticon:Show()
		button = getglobal(mounticon:GetName().."_MountIcon")
		mounttexture = getglobal(mounticon:GetName().."_MountIcon_IconTexture")
		checkbox = getglobal(mounticon:GetName().."_CheckButton")
		checkbox.mountname = mountname
		
		mounticon.link = GetSpellLink(spellID)
		button.link = GetSpellLink(spellID)
		mounttexture:SetTexture(icon)
		checkbox:SetID(i)
		
		button:SetAttribute("type","spell")  --daxdax
		button:SetAttribute("spell",mountname)
	
		if (Mountiful_Selections[panelname]) then
			if (Mountiful_Selections[panelname][mountname]) then
				checkbox:SetChecked(Mountiful_Selections[panelname][mountname]["checked"])
				Mountiful_Selections[panelname][mountname].id = mounts[i]
			else
				checkbox:SetChecked(false)
				Mountiful_Selections[panelname][mountname] = {}
			end
		else
			checkbox:SetChecked(false)
		end

		iconi=iconi+1
	end
	
	--MOprint("Hiding icons +"..iconi)
	mounticon = getglobal("mountifulicon"..iconi)
	while(mounticon) do
		mounticon:Hide()
		iconi=iconi+1
		mounticon = getglobal("mountifulicon"..iconi)
	end
	--MOprint("Hiding end icon "..iconi)

end



function Mountiful_PanelSelect()

	mountifulselectednum = this.categorynum
	mountifulpagenum = 1
	Mountiful_update()
end


function mountifulicon_OnEnter()
	
	--MOprint("ON enter breeched.  link="..this.link)
	GameTooltip:SetOwner(this, "ANCHOR_TOPRIGHT")
	GameTooltip:SetHyperlink(this.link)
	GameTooltip:Show()

end


function CheckBox_OnClick() -- Runs when user clicks the checkbox for a mount

	local mountname = this.mountname
	local panelname = Mountiful_Categories[mountifulselectednum]
	
	MOprint("Cleek.  panelname = "..panelname)

	
	if (not Mountiful_Selections[panelname]) then
		Mountiful_Selections[panelname] = {}
		Mountiful_Selections[panelname][mountname] = {}
	elseif not (Mountiful_Selections[panelname][mountname]) then
		Mountiful_Selections[panelname][mountname] = {}
	end

	if (this:GetChecked()) then -- Mount is now checked, set to checked in Selections and update its id
		MOprint(mountname..": Checked = true; id = "..tostring(id).."; panelname = "..panelname.."; mountname = "..mountname)
		Mountiful_Selections[panelname][mountname]["checked"] = true
	else -- Mount is now unchecked, set to unchecked in Selections and update its id
		Mountiful_Selections[panelname][mountname]["checked"] = false
	end
	
	if Mountiful_Selections[panelname].ispet then
		companiontype = "CRITTER"
	else
		companiontype = "MOUNT"
	end

	Mountiful_Selections[panelname][mountname]["id"] = Mountiful_nametonum(mountname,companiontype)
end

function Mountiful_Mount(panel,pre)
	local ispet,rand,summontype,index,value
	local summontable = {}
	
	MOprint("attempting to call mount from "..panel.."    preselected = "..tostring(pre))
	--MOprint(Mountiful_Selections)
	
	if Mountiful_Selections[panel] and Mountiful_Selections[panel].ispet then
		ispet = true
		summontype = "CRITTER"
	else
		summontype = "MOUNT"
	end
		
	if (not ispet) and (IsMounted()) then -- If player is already mounted dismount
		if IsFlying() and Mountiful_Options.safeflying then -- If player is flying and safeflying is on don't dismount
		else
			Dismount()
		end
	end

	if (pre) then --pre, meaning, use only the checked mounts/pets in that category
		if(Mountiful_Selections[panel]) then
			MOprint("Mountifulselections["..panel.."]  found.  contents:")
			MOprint(Mountiful_Selections[panel])
			for mountname, value in pairs(Mountiful_Selections[panel]) do  --panel is the mount category, first entry is the mount name, value is checked/id table
				if(mountname ~= "ispet" and value.checked) then
					if(ispet and value.id == lastpetsummoned) then  --dont call the same pet twice ina row.  i hate that.
						--skip
					else
						summontable[#summontable+1] = value.id
					end
				end
			end
		else
			MOprint("Nothing is pre-selected for panel "..tostring(panel)..".  Defaulting to non pre-selected.")
			MOprint("Mountiful_Selections[panel]")
			MOprint(tostring(Mountiful_Selections[panel]))
			Mountiful_Mount(panel,false)			
			return
		end
	else
		if(ispet and #Mountiful_Mounts.Pet > 0) then
			summontable = Mountiful_Mounts.Pet
		else
			--if(Mountiful_Categories[panel]) then--dammit its not indexed by string grrr
			if((Mountiful_Mounts[panel]) and (#Mountiful_Mounts[panel] > 0)) then
				summontable = Mountiful_Mounts[panel]  --there was a premade table made in makealltables()
			elseif (#Mountiful_Mounts.All > 0) then--if(Mountiful_Categories[panel]) then--dammit its not indexed by string grrr
				summontable = Mountiful_Mounts.All
				MOprint("No panel found for "..panel.." defaulting to all")
			else
				print("No Mounts found")
				return
			end
		end
	end
	
	if((#summontable == 0)) then  --crap.  infinites
		--MOprint(summontable)  --almost always an error - no, when you select something in flying, say, and nothing in ground, and use the smart pre command.
		MOprint("table found for "..tostring(panel)..".  but all checked were set to false.  Defaulting to non pre-selected.")
		Mountiful_Mount(panel,false)		
		return
		--do nothing
	elseif(#summontable == 1) then
		rand = 1
	elseif(#summontable > 1) then
		rand = random(1,#summontable)
	end
	CallCompanion(summontype, summontable[rand])
	if(ispet) then
		lastpetsummoned = summontable[rand]
	end
	
end

function Mountiful_AddPanel(newpanel, ispet) -- Add a new category
	local exists = false
	if newpanel == nil or newpanel == "" then
		if ispet == true then
			print("Usage: /pet add <panelname>")
		else
			print("Usage: /mount add <panelname>")
		end
	else
		newpanellower = strlower(newpanel)
		if in_array(newpanellower,invalidnames) then
			print(newpanel.." cannot be used as a Category name")
		else
			for index, value in pairs(Mountiful_Categories) do
				if newpanellower == strlower(value) then
					exists = true
				end
			end
			if exists then
				print("Cannot add panel \""..newpanel.."\", it already exists")
			else
				Mountiful_Categories[#Mountiful_Categories+1] = newpanel
				if (not Mountiful_Selections[newpanel]) then
					Mountiful_Selections[newpanel] = { };
				end
				Mountiful_Selections[newpanel].ispet = ispet
			end
			Mountiful_update()
		end
	end
end
function Mountiful_RemovePanel(panel) -- Remove a category
	if panel == nil then
		print("Usage: /mount remove <panelname>")
		return
	elseif panel == "FastFlying" or panel == "FastGround" then
		print("Cannot remove that panel")
		return
	else
		for index, value in pairs(Mountiful_Categories) do
			if strlower(value) == strlower(panel) then
				Mountiful_Categories[index] = nil
				if (Mountiful_Selections[value]) then
					Mountiful_Selections[value] = nil
				end
				print(value.." was removed")
				Mountiful_update()
				return
			end
		end
	end
	print (panel.." was not removed")
end

function Mountiful_SmartMount(predefined)
	local mountnum = GetNumCompanions("MOUNT")
	local flyable
	local zoneName = GetRealZoneText()
	local subZone = GetSubZoneText()
	local ridingSkill = Mountiful_GetRidingSkill()
	local level = UnitLevel("player") -- Get players level
	local tmpnum
	local coldweatherflying, _ = IsUsableSpell(L["Cold Weather Flying"]) -- Does the player have Cold Weather Flying?
	local tablename
	if IsMounted() then -- If player is already mounted dismount
		if IsFlying() and Mountiful_Options.safeflying then -- If player is flying and safeflying is on don't dismount
		else
			Dismount()
		end
		return
	end

	--Get the continent the player is on
	SetMapToCurrentZone()
	currentContinent = GetCurrentMapContinent()

	--Check if area is flyable and if player is allowed to fly there
	flyable = false
	if IsFlyableArea() then
		--If in Northrend and level is at least 77 but you don't have coldweather flying; flyable = false;
		if currentContinent == 4 and not coldweatherflying then
			flyable = false
		else
			--If you are in Wintergrasp or Dalaran and you are not in an subzone where flying is permitted; flyable = false;
			if (zoneName == L["Dalaran"]) and not in_array(subZone, Mountiful_flyableSubZones) then  
				flyable = false
			elseif(zoneName == L["Wintergrasp"] and (not GetWintergraspWaitTime())) then --battle is not in progress if this returns something
				flyable = false
			else
				flyable = true
			end
		end
	else
		flyable = false
	end

	if mountnum ~= Mounts_Count then -- If the number of mounts known is larger then the number stored rebuild the table
		Mountiful_CreateMountTables()
	end

	-- Pick a mount from the first array that is not empty
	if (strfind(zoneName,"Qiraj") and (#Mountiful_Mounts.Qiraj > 0)) then
		tablename = "Qiraj"
	elseif IsSwimming() and #Mountiful_Mounts.Swimming > 0 then
		tablename = "Swimming"	
	elseif IsSwimming() then
		tablename = "FastGround"
	elseif flyable and ridingSkill >= 300 and #Mountiful_Mounts.ExtremeFlying > 0 then
		tablename = "ExtremeFlying"
		--[[  --protected code.  wont work
	elseif flyable and IsUsableSpell("Swift Flight Form")	then
		CastSpellByName("Swift Flight Form")
		return
	elseif flyable and IsUsableSpell("Flight Form")	then
		CastSpellByName("Flight Form")
		return
		]]
	elseif flyable and ridingSkill >= 300 and #Mountiful_Mounts.FastFlying > 0 then
		tablename = "FastFlying"
	elseif flyable and ridingSkill >= 175 and #Mountiful_Mounts.SlowFlying > 0 then
		tablename = "SlowFlying"
	
	elseif #Mountiful_Mounts.FastGround > 0 and ridingSkill >= 150 then
		tablename = "FastGround"
	elseif #Mountiful_Mounts.SlowGround > 0 then
		tablename = "SlowGround"
	else
		print("No mounts available")
		return
	end
	Mountiful_Mount(tablename,predefined)
	--end daxdax
end

--Retrieve and return the players riding skill
function Mountiful_GetRidingSkill()
	for skillIndex = 1, GetNumSkillLines() do
		skillName, _, _, skillRank, _, _, _, _, _, _, _, _, _ = GetSkillLineInfo(skillIndex)
		if skillName == L["Riding"] then
			return skillRank
		end
	end
end

-- Goto next page of mounts/pets
function Mountiful_NextPage()
	mountifulpagenum = mountifulpagenum + 1
	Mountiful_update()
	MOprint("NEXT page.  Now at:"..mountifulpagenum)
end

-- Goto previous page of mounts/pets
function Mountiful_PrevPage()
	mountifulpagenum = mountifulpagenum - 1
	Mountiful_update()
end

function Mountiful_RebuildSelections() -- Rebuild the selections array because it gets messed up after learning new mounts

	local panelname,mountname,ivalue,jvalue,companiontype
	for panelname,ivalue in pairs(Mountiful_Selections) do
		if Mountiful_Selections[panelname].ispet == true then
			companiontype = "CRITTER"
		else
			companiontype = "MOUNT"
		end
		for mountname,jvalue in pairs(Mountiful_Selections[panelname]) do
			if type(jvalue) == "table" then
				if(Mountiful_Selections[panelname][mountname]["checked"]) then
					Mountiful_Selections[panelname][mountname].id = Mountiful_nametonum(mountname,companiontype)
				end
			end
		end
	end

	Mountiful_Mounts = {}
	Mountiful_CreateMountTables()
	Mountiful_update()
end

--Empty Vars and reload the UI
function Mountiful_ResetSettings()
	Mountiful_Vars = nil
	ReloadUI()
end

function Mountiful_CreateMountTables()
	MOprint("Entering |c00ffff00 CreateMountTables")
	local mountnum = GetNumCompanions("MOUNT")
	local petnum = GetNumCompanions("CRITTER")
	local text,link,mountname,spellID,icon
	local ridingSkill = Mountiful_GetRidingSkill()

	-- Empty the mounts tables
	Mountiful_Mounts = {}

	-- Add the categories to the mounts table
	for key,value in pairs(Mountiful_Vars.Categories) do
		Mountiful_Mounts[value] = {}
	end
	Mountiful_Mounts.All = {}

	if(not MountifulTooltip) then
		CreateFrame("GameTooltip", "MountifulTooltip", nil, "GameTooltipTemplate") 
		MountifulTooltip:SetOwner(WorldFrame,"ANCHOR_NONE")
	end
	
	-- Loops through all mounts and sorts them into tables depending on speed and if they can fly
	for i=1, mountnum do
		_, mountname, spellID, icon, _ = GetCompanionInfo("MOUNT", i)
		Mountiful_Mounts.All[#Mountiful_Mounts.All+1] = i
		link = GetSpellLink(spellID)
		MountifulTooltip:SetHyperlink(link) -- Set link for tooltip
		text = _G["MountifulTooltipTextLeft"..3]:GetText() -- Get the description text from the tooltip
			
		if(text) then
			if(strfind (text, L["swimmer"])) then
				Mountiful_Mounts.Swimming[#Mountiful_Mounts.Swimming + 1] = i
			elseif(strfind (text, L["Qiraj"])) then
				Mountiful_Mounts.Qiraj[#Mountiful_Mounts.Qiraj+ 1] = i
			elseif strfind (text, L["changes"]) and strfind (text, L["location"]) then -- Catches mounts that change depending on location and skill
				Mountiful_Mounts.FastFlying[#Mountiful_Mounts.FastFlying+1] = i
				Mountiful_Mounts.SlowFlying[#Mountiful_Mounts.SlowFlying+1] = i
				Mountiful_Mounts.FastGround[#Mountiful_Mounts.FastGround+1] = i
				Mountiful_Mounts.SlowGround[#Mountiful_Mounts.SlowGround+1] = i
			elseif strfind(text, L["changes"]) and not strfind(text, L["Outland"]) then -- Catches mounts that change depending on skill
				Mountiful_Mounts.FastGround[#Mountiful_Mounts.FastGround+1] = i
				Mountiful_Mounts.SlowGround[#Mountiful_Mounts.SlowGround+1] = i
			elseif strfind(text, L["Outland"]) then -- Catches flying mounts
				if ridingSkill >= 300 and strfind(text, L["extremely"]) then -- Catches 310% mounts
					Mountiful_Mounts.ExtremeFlying[#Mountiful_Mounts.ExtremeFlying+1] = i
				elseif ridingSkill >= 300 and (strfind(text, L["very"]) or strfind(text, L["changes"]))then -- Catches epic flyers
					Mountiful_Mounts.FastFlying[#Mountiful_Mounts.FastFlying+1] = i
				else
					Mountiful_Mounts.SlowFlying[#Mountiful_Mounts.SlowFlying+1] = i
				end
			elseif not strfind(text, L["Outland"]) then
				if ridingSkill >= 150 and strfind(text, L["very"])then
					Mountiful_Mounts.FastGround[#Mountiful_Mounts.FastGround+1] = i
				else
					Mountiful_Mounts.SlowGround[#Mountiful_Mounts.SlowGround+1] = i
				end
			end
		end
	end
	
	Mountiful_Mounts.Pet = {}
	for i = 1, petnum do
		_, petnum, spellID, icon, _ = GetCompanionInfo("CRITTER", i)
		Mountiful_Mounts.Pet[#Mountiful_Mounts.Pet+1] = i
	end

	Companion_Counts.Mount = mountnum -- Store the current number of mounts  -? why?  I just did a #Mountiful_Mounts.all and #Mounts.pet (in the update part)
	Companion_Counts.Pet = petnum -- Store the current number of pets  --however i do like that its its own table and not chucked into the Mountiful_Mounts table.  Thats what bugs me about that 'ispet' key.  I'd love to take that out and replace it with a function, so we doing have to throw in is type(x) == table  checks everywhere when looping through tables
end


function Mountiful_nametonum(name, companiontype)
	local mountname, spellID, icon
	local mountnum = GetNumCompanions(companiontype)
	for i=1, mountnum do
		_, mountname, spellID, icon, _ = GetCompanionInfo(companiontype, i)
		if(mountname == name) then
			return i
		end
	end
	return nil
end